## acl2 7.0

=== books/build/jenkins/Makefile ===
# ACL2 Makefile Wrapper
#
# ACL2's makefile unfortunately always rebuilds ACL2, even if it's
# already up to date.  For our build server, this isn't a good idea.
# Run this from your top-level acl2 directory.
#
# General usage:
#
# make -f books/build/jenkins/Makefile <target> LISP=<command>
#
# Example usages:
#
# make -f books/build/jenkins/Makefile acl2 LISP=ccl
# make -f books/build/jenkins/Makefile acl2hr LISP=ccl
# make -f books/build/jenkins/Makefile saved_acl2p LISP=ccl

ACL2_ALL_SOURCES  := $(wildcard *.lisp)
ACL2_FAKE_SOURCES := acl2-proclaims.lisp acl2r.lisp
ACL2_SOURCES      := $(filter-out $(ACL2_FAKE_SOURCES), $(ACL2_ALL_SOURCES))
ACL2_DEPS         := $(ACL2_SOURCES) GNUmakefile

.PHONY: acl2 acl2h acl2p acl2r acl2hp acl2hr acl2pr acl2hpr

acl2: saved_acl2
acl2h: saved_acl2h
acl2p: saved_acl2p
acl2r: saved_acl2r
acl2hp: saved_acl2hp
acl2hr: saved_acl2hr
acl2pr: saved_acl2pr
acl2hpr: saved_acl2hpr

# Note that we don't use &>, because otherwise the process goes on
# immediately, and waiting 100 seconds isn't enough for SBCL builds.
saved_acl2: $(ACL2_DEPS)
	echo "Making ACL2() on $(LISP)"
	time make --file=GNUmakefile LISP=$(LISP) ACL2_HONS= > make-acl2.log
	./books/build/wait.pl make-acl2.log
	cat make-acl2.log
	./books/build/wait.pl saved_acl2
	ls -lah saved_acl2

saved_acl2h: $(ACL2_DEPS)
	echo "Making ACL2(h) on $(LISP)"
	time make --file=GNUmakefile LISP=$(LISP) ACL2_HONS=h > make-acl2.log
	./books/build/wait.pl make-acl2.log
	cat make-acl2.log
	./books/build/wait.pl saved_acl2h
	ls -lah saved_acl2h

saved_acl2p: $(ACL2_DEPS)
	echo "Making ACL2(p) on $(LISP)"
	time make --file=GNUmakefile LISP=$(LISP) ACL2_HONS= ACL2_PAR=p > make-acl2.log
	./books/build/wait.pl make-acl2.log
	cat make-acl2.log
	./books/build/wait.pl saved_acl2p
	ls -lah saved_acl2p

saved_acl2r: $(ACL2_DEPS)
	echo "Making ACL2(r) on $(LISP)"
	time make --file=GNUmakefile LISP=$(LISP) ACL2_HONS= ACL2_REAL=r > make-acl2.log
	./books/build/wait.pl make-acl2.log
	cat make-acl2.log
	./books/build/wait.pl saved_acl2r
	ls -lah saved_acl2r

saved_acl2hp: $(ACL2_DEPS)
	echo "Making ACL2(hp) on $(LISP)"
	time make --file=GNUmakefile LISP=$(LISP) ACL2_HONS=h ACL2_PAR=p > make-acl2.log
	./books/build/wait.pl make-acl2.log
	cat make-acl2.log
	./books/build/wait.pl saved_acl2hp
	ls -lah saved_acl2hp

saved_acl2hr: $(ACL2_DEPS)
	echo "Making ACL2(hr) on $(LISP)"
	time make --file=GNUmakefile LISP=$(LISP) ACL2_HONS=h ACL2_REAL=r > make-acl2.log
	./books/build/wait.pl make-acl2.log
	cat make-acl2.log
	./books/build/wait.pl saved_acl2hr
	ls -lah saved_acl2hr

saved_acl2pr: $(ACL2_DEPS)
	echo "Making ACL2(pr) on $(LISP)"
	time make --file=GNUmakefile LISP=$(LISP) ACL2_HONS= ACL2_PAR=p ACL2_REAL=r > make-acl2.log
	./books/build/wait.pl make-acl2.log
	cat make-acl2.log
	./books/build/wait.pl saved_acl2pr
	ls -lah saved_acl2pr

saved_acl2hpr: $(ACL2_DEPS)
	echo "Making ACL2(hpr) on $(LISP)"
	time make --file=GNUmakefile LISP=$(LISP) ACL2_HONS=h ACL2_PAR=p ACL2_REAL=r > make-acl2.log
	./books/build/wait.pl make-acl2.log
	cat make-acl2.log
	./books/build/wait.pl saved_acl2hpr
	ls -lah saved_acl2hpr

=== books/system/toothbrush/Makefile ===
# Copyright (C) 2014, ForrestHunt, Inc.
# Written by Matt Kaufmann, November, 2014
# License: A 3-clause BSD license.  See the LICENSE file distributed with ACL2.

# The toothbrush is not part of the normal regression, because a lisp
# must be specified.  That lisp is currently required to be CCL or
# SBCL, because these compile on-the-fly and we load ACL2 source
# files, not compiled files -- though that restriction could possibly
# be removed.

# The next variable, TB_LISP, specifies the Lisp to be used.  We avoid
# using LISP since that is the name used in the main ACL2 GNUmakefile,
# and someone might set it without intending to run toothbrush tests.
# This variable must be set in order to run "make" with this Makefile.
# For regressions, books/GNUmakefile skips running "make" in this
# directory if TB_LISP is not defined.  To run directly in this
# directory, edit the next line or designate a Lisp executable for
# TB_LISP in the environment or on the command line.
# TB_LISP ?= ccl

# For example:
# make ACL2=/Users/kaufmann/acl2/acl2/saved_acl2h TB_LISP=ccl

ifneq ($(ACL2), $(notdir $(ACL2)))
ACL2_DIR := $(dir $(ACL2))
ACL2_SYSTEM_BOOKS ?= $(ACL2_DIR)books
else
ifneq ($(ACL2_SYSTEM_BOOKS), )
ACL2_DIR := $(dir $(ACL2_SYSTEM_BOOKS)/../)
endif
endif

# Note that ACL2 is typically set by the top-level GNUmakefile for a
# regression, but when using books/GNUmakefile directly, ACL2 is acl2
# by default.  If using cert.pl directly, then this directory will be
# skipped -- one must invoke this Makefile.

success.txt: acl2_check lisp_check defined-syms.lsp make-toothbrush.cert
	@(cd tests ; $(MAKE)) || \
	  (echo "`pwd`/$@: **CERTIFICATION FAILED**"; exit 1)
	@echo "Tests passed." > success.txt

.PHONY: acl2_check
acl2_check:
	@if [ "$(ACL2)" = "" ] ; then \
	echo "ERROR: Environment (or make) variable ACL2 must be";\
	echo "       defined.  It needs to be set to a pathname whose";\
	echo "       directory contains relevant ACL2 source files.";\
	exit 1 ;\
	fi
# The following test avoids failure to set ACL2_SYSTEM_BOOK suitably
# when, for example, specifying ACL2=acl2.
	@if [ "$(ACL2_SYSTEM_BOOKS)" = "" ] ; then \
	echo "ERROR: Environment (or make) variable ACL2_SYSTEM_BOOKS";\
	echo "       must be set.  This may happen automatically if ACL2";\
	echo "       is set not just to an executable, but to a pathname";\
	echo "       whose directory contains relevant ACL2 source files.";\
	exit 1 ;\
	fi
	@echo "Note: For toothbrush, ACL2_DIR = $(ACL2_DIR)."

.PHONY: lisp_check
lisp_check:
	@if [ "$(TB_LISP)" = "" ] ; then \
	echo "ERROR: Environment (or make) variable TB_LISP must be";\
	echo "       defined, to designate a Lisp executable.";\
	exit 1 ;\
	fi

# Note that ACL2_SYSTEM_BOOKS is what defines BOOKS_CERT.
ifneq ($(ACL2_SYSTEM_BOOKS), )
include $(ACL2_SYSTEM_BOOKS)/Makefile-generic
-include Makefile-deps
endif

defined-syms.lsp: acl2_check lisp_check load-toothbrush.lsp make-defined-syms.lsp
	@echo '(defparameter COMMON-LISP-USER::*acl2-dir* "$(ACL2_DIR)") (load "make-defined-syms.lsp") (acl2::exit-lisp)' > workxxx.$@
	@($(TB_LISP) < workxxx.$@ 2>&1) > $@.out
	@echo "Created $@"

# We don't bother with a target for making make-toothbrush.cert, since
# such certification is not necessary.

clean: acl2_check clean-extras clean-tests

.PHONY: clean-extras clean-tests

clean-extras:
	rm -f defined-syms.lsp
	rm -f success.txt

clean-tests:
	cd tests ; $(MAKE) clean

=== books/centaur/vl/failtest/Makefile ===
# VL Verilog Toolkit
# Copyright (C) 2008-2014 Centaur Technology
#
# Contact:
#   Centaur Technology Formal Verification Group
#   7600-C N. Capital of Texas Highway, Suite 300, Austin, TX 78731, USA.
#   http://www.centtech.com/
#
# License: (An MIT/X11-style license)
#
#   Permission is hereby granted, free of charge, to any person obtaining a
#   copy of this software and associated documentation files (the "Software"),
#   to deal in the Software without restriction, including without limitation
#   the rights to use, copy, modify, merge, publish, distribute, sublicense,
#   and/or sell copies of the Software, and to permit persons to whom the
#   Software is furnished to do so, subject to the following conditions:
#
#   The above copyright notice and this permission notice shall be included in
#   all copies or substantial portions of the Software.
#
#   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
#   IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
#   FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
#   AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
#   LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
#   FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
#   DEALINGS IN THE SOFTWARE.
#
# Original author: Jared Davis <jared@centtech.com>

.PHONY: all clean

STARTJOB ?= bash
VL       ?= $(PWD)/../bin/vl

SPEC_FILES := $(wildcard *.v)
VOK_FILES  := $(patsubst %.v, %.vok,  $(SPEC_FILES))
SVOK_FILES := $(patsubst %.v, %.svok, $(SPEC_FILES))



%.vok: %.v
	@echo "Making $*.ok"
	@rm -f $*.vok
	@$(STARTJOB) -c "$(VL) model $*.v --mem=2 --search=. --mustfail=top --edition=Verilog --model-file=$*.v.model.sao --esims-file=$*.v.esims.sao --verilog-file=$*.v.pp &> $*.vok.log"
	@rm $*.v.esims.sao $*.v.model.sao $*.v.model.sao.ver $*.v.pp
	@cp $*.vok.log $*.vok
	@ls -l $*.vok

%.svok: %.v
	@echo "Making $*.svok"
	@rm -f $*.svok
	@$(STARTJOB) -c "$(VL) model $*.v --mem=2 --search=. --mustfail=top --edition=SystemVerilog --model-file=$*.sv.model.sao --esims-file=$*.sv.esims.sao --verilog-file=$*.sv.pp &> $*.svok.log"
	@rm $*.sv.esims.sao $*.sv.model.sao $*.sv.model.sao.ver $*.sv.pp
	@cp $*.svok.log $*.svok
	@ls -l $*.svok

all: $(VOK_FILES) $(SVOK_FILES)



clean:
	rm -f *.vok *.svok *.log *.sao *.pp *.sao.ver
	rm -rf csrc INCA_libs simv.daidir
	rm -f simv ucli.key *.log

=== books/centaur/vl/systest/Makefile ===
# VL Verilog Toolkit
# Copyright (C) 2008-2014 Centaur Technology
#
# Contact:
#   Centaur Technology Formal Verification Group
#   7600-C N. Capital of Texas Highway, Suite 300, Austin, TX 78731, USA.
#   http://www.centtech.com/
#
# License: (An MIT/X11-style license)
#
#   Permission is hereby granted, free of charge, to any person obtaining a
#   copy of this software and associated documentation files (the "Software"),
#   to deal in the Software without restriction, including without limitation
#   the rights to use, copy, modify, merge, publish, distribute, sublicense,
#   and/or sell copies of the Software, and to permit persons to whom the
#   Software is furnished to do so, subject to the following conditions:
#
#   The above copyright notice and this permission notice shall be included in
#   all copies or substantial portions of the Software.
#
#   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
#   IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
#   FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
#   AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
#   LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
#   FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
#   DEALINGS IN THE SOFTWARE.
#
# Original author: Jared Davis <jared@centtech.com>

.PHONY: all clean debug ncv vcs

all: ncv vcs

STARTJOB ?= bash
VL       ?= $(PWD)/../bin/vl

SPEC_FILES        := $(wildcard */spec.v)
TEST_DIRS         := $(patsubst %/spec.v, %,                   $(SPEC_FILES))

NCV_V_IMPL_FILES  := $(patsubst %/spec.v, %/impl.ncv.v,        $(SPEC_FILES))
NCV_SV_IMPL_FILES := $(patsubst %/spec.v, %/impl.ncv.sv,       $(SPEC_FILES))
NCV_V_OKS         := $(patsubst %/spec.v, %/ncv.v.ok,          $(SPEC_FILES))
NCV_SV_OKS        := $(patsubst %/spec.v, %/ncv.sv.ok,         $(SPEC_FILES))

ncv: $(NCV_V_IMPL_FILES)
ncv: $(NCV_SV_IMPL_FILES)
ncv: $(NCV_V_OKS)
ncv: $(NCV_SV_OKS)

VCS_V_IMPL_FILES  := $(patsubst %/spec.v, %/impl.vcs.v,        $(SPEC_FILES))
VCS_SV_IMPL_FILES := $(patsubst %/spec.v, %/impl.vcs.sv,       $(SPEC_FILES))
VCS_V_OKS         := $(patsubst %/spec.v, %/vcs.v.ok,          $(SPEC_FILES))
VCS_SV_OKS        := $(patsubst %/spec.v, %/vcs.sv.ok,         $(SPEC_FILES))

vcs: $(VCS_V_IMPL_FILES)
vcs: $(VCS_SV_IMPL_FILES)
vcs: $(VCS_V_OKS)
vcs: $(VCS_SV_OKS)

impls: $(NCV_V_IMPL_FILES) $(NCV_SV_IMPL_FILES) $(VCS_V_IMPL_FILES) $(VCS_SV_IMPL_FILES)

NCV_VERILOG    := ncverilog +access+r      +define+VL_SYSTEST_NCV
NCV_SYSVERILOG := ncverilog +access+r +sv  +define+VL_SYSTEST_NCV +define+SYSTEM_VERILOG_MODE
VCS_VERILOG    := vcs -o simv.v            +define+VL_SYSTEST_VCS
VCS_SYSVERILOG := vcs -o simv.sv -sverilog +define+VL_SYSTEST_VCS +define+SYSTEM_VERILOG_MODE

XLATE_NCV_V    := $(VL) model spec.v --mem=2 --search=. --verilog-file=impl.ncv.v  --define=VL_SYSTEST_NCV --edition=Verilog
XLATE_NCV_SV   := $(VL) model spec.v --mem=2 --search=. --verilog-file=impl.ncv.sv --define=VL_SYSTEST_NCV --edition=SystemVerilog --define=SYSTEM_VERILOG_MODE
XLATE_VCS_V    := $(VL) model spec.v --mem=2 --search=. --verilog-file=impl.vcs.v  --define=VL_SYSTEST_VCS --edition=Verilog
XLATE_VCS_SV   := $(VL) model spec.v --mem=2 --search=. --verilog-file=impl.vcs.sv --define=VL_SYSTEST_VCS --edition=SystemVerilog --define=SYSTEM_VERILOG_MODE

%/impl.ncv.v: %/spec.v
	@echo "Making $*/impl.ncv.v"
	@rm -f %/impl.ncv.v %/impl.ncv.v.out
	@cd $*; $(STARTJOB) -c \
	  'echo `hostname` &> impl.ncv.v.out; $(XLATE_NCV_V) &>> impl.ncv.v.out'
	@ls -l $*/impl.ncv.v

%/impl.ncv.sv: %/spec.v
	@echo "Making $*/impl.ncv.sv"
	@rm -f %/impl.ncv.sv %/impl.ncv.sv.out
	@cd $*; $(STARTJOB) -c \
	  'echo `hostname` &> impl.ncv.sv.out; $(XLATE_NCV_SV) &>> impl.ncv.sv.out'
	@ls -l $*/impl.ncv.sv

%/impl.vcs.v: %/spec.v
	@echo "Making $*/impl.vcs.v"
	@rm -f %/impl.vcs.v %/impl.vcs.v.out
	@cd $*; $(STARTJOB) -c \
	  'echo `hostname` &> impl.vcs.v.out; $(XLATE_VCS_V) &>> impl.vcs.v.out'
	@ls -l $*/impl.vcs.v

%/impl.vcs.sv: %/spec.v
	@echo "Making $*/impl.vcs.sv"
	@rm -f %/impl.vcs.sv %/impl.vcs.sv.out
	@cd $*; $(STARTJOB) -c \
	  'echo `hostname` &> impl.vcs.sv.out; $(XLATE_VCS_SV) &>> impl.vcs.sv.out'
	@ls -l $*/impl.vcs.sv

%/ncv.v.ok: %/impl.ncv.v %/spec.v $(wildcard %/compare*.v)
	@echo "Making $*/ncv.v.out"
	@cd $*; $(STARTJOB) -c "$(NCV_VERILOG) compare.v spec.v impl.ncv.v &> ncv.v.out" \
           || (echo "NCV command failed for $*." ;\
	       ../errcheck.pl ncv.v.out ;\
	       false)
	@ls -l $*/ncv.v.out
	@./errcheck.pl $*/ncv.v.out
	@cp $*/ncv.v.out $*/ncv.v.ok

%/ncv.sv.ok: %/impl.ncv.sv %/spec.v $(wildcard %/compare*.v)
	@echo "Making $*/ncv.sv.out"
	@cd $*; $(STARTJOB) -c "$(NCV_SYSVERILOG) compare.v spec.v impl.ncv.sv &> ncv.sv.out" \
           || (echo "NCV command failed for $*." ;\
	       ../errcheck.pl ncv.sv.out ;\
	       false)
	@ls -l $*/ncv.sv.out
	@./errcheck.pl $*/ncv.sv.out
	@cp $*/ncv.sv.out $*/ncv.sv.ok

%/vcs.v.ok: %/impl.vcs.v $(wildcard %/compare*.v)
	@echo "Making $*/vcs.v.out"
	@cd $*; $(STARTJOB) -c "$(VCS_VERILOG) compare.v spec.v impl.vcs.v &> vcs.v.out; ./simv.v &>> vcs.v.out" \
            || (echo "VCS command failed for $*." ;\
	       ../errcheck.pl vcs.v.out ;\
	       false)
	@ls -l $*/vcs.v.out
	@./errcheck.pl $*/vcs.v.out
	@cp $*/vcs.v.out $*/vcs.v.ok

%/vcs.sv.ok: %/impl.vcs.sv $(wildcard %/compare*.v)
	@echo "Making $*/vcs.sv.out"
	@cd $*; $(STARTJOB) -c "$(VCS_SYSVERILOG) compare.v spec.v impl.vcs.sv &> vcs.sv.out; ./simv.sv &>> vcs.sv.out" \
            || (echo "VCS command failed for $*." ;\
	       ../errcheck.pl vcs.sv.out ;\
	       false)
	@ls -l $*/vcs.sv.out
	@./errcheck.pl $*/vcs.sv.out
	@cp $*/vcs.sv.out $*/vcs.sv.ok



# Stupid little aliases so you can just type, e.g., "make case" to do the
# testes in the case/ directory.

.PHONY: $(TEST_DIRS)

define mkDirTarget
$(1): $(1)/ncv.sv.ok
$(1): $(1)/ncv.v.ok
$(1): $(1)/vcs.sv.ok
$(1): $(1)/vcs.v.ok
endef

$(foreach dir, $(TEST_DIRS), $(eval $(call mkDirTarget, $(dir))))




clean:
	rm -f */impl.*.v */impl.*.sv
	rm -f */*.sao */*.sao.ver
	rm -f */*.log */*.out */*.ok
	rm -rf */INCA_libs */*.vcd */*.key
	rm -rf */simv.*.daidir
	rm -rf */csrc

=== books/workshops/2003/kaufmann/support/input/Makefile ===
include ../../../../../Makefile-generic

# Avoid provisional certification since we are not using Makefile-deps
# (because there are generated .lisp files):
override ACL2_PCERT =

BOOKS = defs-in inputs lemmas-in defs-out defs-eq lemmas-out 

FAILED = 0

all: check.txt

# Compare generated .lisp files against expected files, in ../output/ directory.
check.txt: defs-eq.cert defs-out.cert lemmas-in.cert defs-in.cert inputs.cert lemmas-out.cert 
	@diff defs-out.lisp ../output/defs-out.lisp || (echo "defs-out.lisp failed" ; $(MAKE) -s --no-print-directory FAILED)
	@diff defs-eq.lisp ../output/defs-eq.lisp || (echo "defs-eq.lisp failed" ; $(MAKE) -s --no-print-directory FAILED)
	@diff lemmas-out.lisp ../output/lemmas-out.lisp || (echo "lemmas-out.lisp failed" ; $(MAKE) -s --no-print-directory FAILED)
	touch check.txt

# Dependencies:

# Created manually:

defs-eq.lisp lemmas-out.lisp: defs-out.lisp

defs-out.lisp: defs-in.cert lemmas-in.lisp ../../../../../misc/simplify-defuns.cert
	$(ACL2) < defs-out.cmds > defs-out.lisp.out

clean: clean-more

clean-more:
	rm -f defs-out.lisp defs-eq.lisp lemmas-out.lisp check.txt

# Created with make dependencies after a successful run:

defs-in.cert: defs-in.lisp
defs-in.cert: defs-in.acl2
defs-in.cert: inputs.cert

inputs.cert: inputs.lisp

lemmas-in.cert: lemmas-in.lisp
lemmas-in.cert: defs-in.cert

defs-out.cert: defs-out.lisp
defs-out.cert: defs-out.acl2
defs-out.cert: inputs.cert

defs-eq.cert: defs-eq.lisp
defs-eq.cert: defs-eq.acl2
defs-eq.cert: defs-in.cert
defs-eq.cert: defs-out.cert

lemmas-out.cert: lemmas-out.lisp
lemmas-out.cert: defs-out.cert
lemmas-out.cert: lemmas-in.cert
lemmas-out.cert: defs-eq.cert

=== debian/changelog ===
acl2 (7.0-1) unstable; urgency=medium

  * New upstream release

 -- Camm Maguire <camm@debian.org>  Fri, 16 Jan 2015 10:35:45 -0500

acl2 (6.5-5) unstable; urgency=medium

  * fix syntax error in debian/rules

 -- Camm Maguire <camm@debian.org>  Sun, 26 Oct 2014 12:51:22 -0400

acl2 (6.5-4) unstable; urgency=medium

  * restore tick output for slow autobuilders

 -- Camm Maguire <camm@debian.org>  Sat, 25 Oct 2014 09:01:06 -0400

acl2 (6.5-3) unstable; urgency=medium

  * build-dep latest gcl
  * abort centaur/vl/top cert if insufficient memory (mips autobuild)

 -- Camm Maguire <camm@debian.org>  Fri, 24 Oct 2014 14:07:33 -0400

=== debian/control ===
Source: acl2
Section: math
Priority: optional
Maintainer: Camm Maguire <camm@debian.org>
Build-Depends: gcl ( >= 2.6.11-6 ), libgmp3-dev, libreadline-dev, emacs24 | emacsen, debhelper ( >= 5 ), texlive-latex-recommended, libxmu-dev, libxaw7-dev, time, tex-common, texinfo
Standards-Version: 3.9.5

Package: acl2
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: acl2-source, acl2-books
Suggests: acl2-emacs
Description: Computational Logic for Applicative Common Lisp: main binary
 ACL2 is both a programming language in which you can model computer
 systems and a tool to help you prove properties of those models.
 .
 This package contains the base ACL2 binary. 

Package: acl2-source
Architecture: all
Conflicts: acl2 (<= 2.7-9)
Replaces: acl2 (<= 2.7-9)
Depends: ${misc:Depends}	  
Description: Computational Logic for Applicative Common Lisp: source files
 ACL2 is both a programming language in which you can model computer
 systems and a tool to help you prove properties of those models.
 .
 This package contains the lisp source files to the main ACL2 binary.

Package: acl2-emacs
Architecture: all
Depends: acl2 (>= ${source:Version}), emacs24 | emacsen, ${misc:Depends}
Conflicts: acl2 (<= 2.7-9)
Replaces: acl2 (<= 2.7-9)
Description: Computational Logic for Applicative Common Lisp: emacs interface
 ACL2 is both a programming language in which you can model computer
 systems and a tool to help you prove properties of those models.
 .
 This package contains an emacs interface to ACL2.

Package: acl2-infix
Architecture: any
Recommends: acl2-infix-source (= ${source:Version})
Depends: acl2 (= ${binary:Version}), texlive-latex-recommended, ${misc:Depends}
Conflicts: acl2 (<= 2.7-9)
Replaces: acl2 (<= 2.7-9)
Description: Computational Logic for Applicative Common Lisp: infix interface
 ACL2 is both a programming language in which you can model computer
 systems and a tool to help you prove properties of those models.
 .
 This package contains utilities and libraries to access ACL2 via an
 infix notation similar to that used in many non-lisp programming
 languages.

Package: acl2-infix-source
Architecture: all
Depends: ${misc:Depends}
Conflicts: acl2 (<= 2.7-9)
Replaces: acl2 (<= 2.7-9)
Description: Computational Logic for Applicative Common Lisp: infix source
 ACL2 is both a programming language in which you can model computer
 systems and a tool to help you prove properties of those models.
 .
 This package contains the source files to the infix interface to
 ACL2.

Package: acl2-books
Architecture: any
Depends: acl2 (= ${binary:Version}), acl2-books-certs (= ${source:Version}), acl2-books-source (= ${source:Version}), ${misc:Depends}
Conflicts: acl2 (<= 2.7-9)
Replaces: acl2 (<= 2.7-9)
Description: Computational Logic for Applicative Common Lisp: compiled libraries
 ACL2 is both a programming language in which you can model computer
 systems and a tool to help you prove properties of those models.
 .
 This package contains numerous precompiled and precertified libraries
 for use in proving theorems with ACL2.  Serious users will no doubt
 want to install this package.

Package: acl2-books-source
Architecture: all
Depends: acl2 (>= ${source:Version}), ${misc:Depends}
Conflicts: acl2 (<= 2.7-9)
Replaces: acl2 (<= 2.7-9)
Description: Computational Logic for Applicative Common Lisp: library sources
 ACL2 is both a programming language in which you can model computer
 systems and a tool to help you prove properties of those models.
 .
 This package contains source lisp files to the compiled libraries
 supplied in the ACL2-books package.

Package: acl2-books-certs
Architecture: all
Depends: acl2 (>= ${source:Version}), ${misc:Depends}
Conflicts: acl2 (<= 2.7-9)
Replaces: acl2 (<= 2.7-9)
Description: Computational Logic for Applicative Common Lisp: library certificates
 ACL2 is both a programming language in which you can model computer
 systems and a tool to help you prove properties of those models.
 .
 This file contains certification records for the various precompiled
 libraries supplied in the ACL2-books package.  ACL2 essentially
 requires that all included books be certified before use.

Package: acl2-doc
Depends: ${misc:Depends}, dpkg (>= 1.15.4) | install-info
Architecture: all
Section: doc
Description: Computational Logic for Applicative Common Lisp: documentation
 ACL2 is both a programming language in which you can model computer
 systems and a tool to help you prove properties of those models.
 .
 This package contains the documentation for ACL2.

=== debian/rules ===
#!/usr/bin/make -f
# Sample debian/rules that uses debhelper. 
# GNU copyright 1997 by Joey Hess.
#
# This version is for a hypothetical package that builds an
# architecture-dependant package, as well as an architecture-independent
# package.

# Uncomment this to turn on verbose mode. 
#export DH_VERBOSE=1

# This is the debhelper compatability version to use.
#export DH_COMPAT=4

# This has to be exported to make some magic below work.
export DH_OPTIONS

PN:=acl2
VR:=$(shell awk '{if (i) next;i=1;a=$$2;gsub("[()]","",a);split(a,A,"-");print A[1];}' debian/changelog)
PD:=$(PN)-$(VR)


NO_STRIP:=
# ifeq ($(DEB_BUILD_ARCH),powerpc)
# NO_STRIP:=--exclude=saved_acl2
# endif

NUMJOBS:=1
ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
  NUMJOBS:=$(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
endif
NUMJOBS:=$(shell if test $(NUMJOBS) -gt 8; then echo 8 ; else echo $(NUMJOBS); fi)

#books/workshops:
#	mkdir $@

#init.lsp.ori: 
#	[ -e $@ ] || mv init.lsp $@

DLOPEN_T:=debian/dlopen.lisp #init.lsp.ori 

#ifeq ($(DEB_BUILD_ARCH),ia64)
#DLOPEN?=$(DLOPEN_T)
#endif
#ifeq ($(DEB_BUILD_ARCH),alpha)
#DLOPEN?=$(DLOPEN_T)
#endif
#ifeq ($(DEB_BUILD_ARCH),mips)
#DLOPEN?=$(DLOPEN_T)
#endif
#ifeq ($(DEB_BUILD_ARCH),mipsel)
#DLOPEN?=$(DLOPEN_T)
#endif
#ifeq ($(DEB_BUILD_ARCH),hppa)
#DLOPEN?=$(DLOPEN_T)
#endif

debian/dlopen.lisp: debian/dlopen.lisp.in
	cat $< | sed "s,@VR@,$(VR),g" > $@

debian/acl2-emacs.emacsen-startup: debian/acl2-emacs.emacsen-startup.in
	cat $< | sed "s,@VR@,$(VR),g" > $@

saved_acl2h: $(DLOPEN_T) #debian/patches_applied 
#	echo '(progn (load "debian/sublis_patch.lsp")(si::save-system "pgcl"))' | gcl
	gcl -batch -eval "(bye #-native-reloc 1)" || \
		(gcl -batch -eval '(load "debian/dlopen.lisp")' && $(MAKE) do_saved)
	gcl -batch -eval "(bye #+native-reloc 1)" || $(MAKE) GCL_ANSI=t LISP=gcl
	mv *$@.gcl $@

saved_acl2h.c: saved_acl2h
	echo "(f-put-global 'old-certification-dir \"$$(pwd)/books\" state)" \
              "(f-put-global 'new-certification-dir \"/usr/share/$(PD)/books\" state)" \
	      ":q #-native-reloc (setq si::*multiply-stacks* 4) :q (in-package :acl2) " \
	      "#+(or sparc sparc64)(progn (si::sgc-on nil) (fmakunbound 'si::sgc-on))" \
              "(save-exec \"$@\" \"Modified to produce final certification files\")" | HOME=$$(pwd) ./$<
	mv $@.gcl $@

debian/mini-proveall.out: saved_acl2h
	HOME=$$(pwd) $(MAKE) mini-proveall
	mv $(@F) $@

books/short-test.log: saved_acl2h.c
	cp saved_acl2h saved_acl2h.ori
	HOME=$$(pwd) $(MAKE) certify-books-short
	cp saved_acl2h.ori saved_acl2h

#	tail -f --pid=$$j --retry $@ $$(find books -name "*.lisp" | sed 's,\.lisp$$,.out,1') & \

debian/test.log: saved_acl2h.c
	mv saved_acl2h saved_acl2h.ori
	cp $< saved_acl2h
	BUILDDIR="$$(dirname $$(pwd))" \
	FINALDIR="/usr/share/$(PD)" \
	HOME=$$(pwd) \
	EXCLUDED_PREFIXES=centaur/tutorial/alu16-book \
	$(MAKE) -j $(NUMJOBS) -l 2.95 certify-books >$@ 2>&1 & j=$$! ; \
	while sleep 1800; do echo Tick; done & k=$$! ; tail -f debian/test.log & l=$$! ; \
	wait $$j ; kill $$k $$l
	[ -f $@ ] && ! fgrep '**' $@ || (echo FULL TEST FAILS ;\
		for i in $$(find books -name "*.out"); do \
			if ! [ -e $${i%out}cert ] ; then \
				echo $$i ; \
				cat $$i ; \
			fi ; \
		done)
	mv saved_acl2h.ori saved_acl2h
	[ -f $@ ] && ( ! fgrep '**' $@ || \
	  gcl -batch -eval "(bye #-native-reloc 0 #+native-reloc (let ((w (multiple-value-bind (a b c d) (si::heap-report) (/ (- d c) (/ a 8))))) (format t \"certification run with ~s heap words~%\" w) (if (< w 500000000) 0 1)))")

books/interface/infix/Makefile: books/interface/infix/makefile
	sed -e "s,^DIR = .*,DIR = $$(pwd)/books/interface/infix,1" \
	    -e "s,^LISP = .*,LISP = $$(pwd)/saved_acl2h,1" $< > $@

infix-stamp: books/interface/infix/Makefile saved_acl2h
	cd books/interface/infix && make -f Makefile compile 
	cd books/interface/infix && make -f Makefile example 
#	cd books/interface/infix && make -f Makefile events 
	touch $@

doc/TEX/acl2-book.ps.gz: saved_acl2h
	HOME=$$(pwd) $(MAKE) DOC
	rm -f doc/HTML/LICENSE
	find doc -empty -exec rm {} \;

build: build-arch build-indep
build-arch: build-stamp
build-indep: build-stamp
build-stamp: debian/mini-proveall.out debian/test.log infix-stamp # doc/TEX/acl2-book.ps.gz
	dh_testdir

#	$(MAKE)

	touch build-stamp

infix_clean: books/interface/infix/Makefile
	rm -f infix-stamp 
	cd books/interface/infix && make -f Makefile clean
	rm -f books/interface/infix/Makefile


debian/dpatches: debian/patches.in
	debian/rules debian/patches_unapplied
	cat $< | sed -e "s,@BDIR@,$$(pwd),1" -e "s,@DDIR@,/usr/share/$(PD),1" >$@

debian/patches_applied: debian/dpatches
	! [ -e debian/patches_unapplied ] || \
		(patch -p1 < $< && rm -f debian/patches_unapplied)
	touch $@

debian/patches_unapplied: 
	! [ -e debian/patches_applied ] || ! [ -e debian/dpatches ] ||  \
		(patch -p1 -R < debian/dpatches && rm -f debian/patches_applied)
	touch $@


INSTALLS:=$(addprefix debian/,$(addsuffix .install,acl2 acl2-source acl2-emacs acl2-doc acl2-books acl2-books-source acl2-books-certs acl2-infix acl2-infix-source))
LINKS:=$(addprefix debian/,$(addsuffix .links,acl2 acl2-books acl2-infix))
IFILES:=$(INSTALLS) $(shell ls -1 debian/*.examples debian/*.docs)
debian/README.Debian: debian/README.Debian.in $(IFILES)
	awk '/@PLIST@/ {exit 0} {print}' $< >$@
	for i in $(filter %.install,$^); do\
	 awk '/^debian\// {next} {sub(".final$$","",$$1);$$2="/" $$2;print $$0 " " p}' \
		p=$$(basename $${i%.install}) $$i >>$@ ; done
	for i in $(filter %.info,$^); do\
	 awk '/^debian\// {next} {print $$0 " /usr/share/info " p}' p=$$(basename $${i%.info}) $$i >>$@ ; done
	for i in $(filter %.examples,$^); do\
	 awk '/^debian\// {next} {print $$0 " /usr/share/doc/" p "/examples " p}' \
		p=$$(basename $${i%.examples}) $$i >>$@ ; done
	for i in $(filter %.docs,$^); do\
	 awk '/^debian\// {next} {print $$0 " /usr/share/doc/" p " " p}' p=$$(basename $${i%.docs}) $$i >>$@ ; done
	awk '/@PLIST@/ {i=1;next} {if (i) print}' $< >>$@

clean: infix_clean #debian/patches_unapplied books/workshops
	dh_testdir
	dh_testroot
	rm -f build-stamp 

	$(MAKE) clean
	$(MAKE) clean-books
	find books -name "*.final" -exec rm {} \;
	rm -f saved_acl2h init_nsaved1_acl2.lsp worklispext
	rm -f debian/mini-proveall.out books/short-test.log debian/test.log
#	! [ -e init.lsp.ori ] || mv init.lsp.ori init.lsp
	rm -f foo.lsp nsaved_acl2h
	for i in data c h ; do \
		for j in $$(find -name "*.$$i") ; do\
			k=$$(echo $$j | sed "s,\.$$i$$,,1") ;\
			! [ -e $$k.lisp ] || rm $$j ; \
		done ; \
	done
	rm -f books/bdd/benchmarks.data acl2r.lisp tmp
	rm -f debian/dpatches $(INSTALLS) $(LINKS) debian/README.Debian saved_acl2h*
	rm -f debian/dlopen.lisp debian/acl2-emacs.emacsen-startup
	rm -f debian/acl2.sh pgcl books/Makefile-tmp books/coi/gensym/gensym.out
	rm -f books/coi/gensym/Makefile-deps books/coi/gensym/workxxx.gensym books/system/doc/rendered-doc.lsp
	rm -rf doc/HTML-old doc/EMACS-old doc/acl2-wc.txt books/std/io/test.sao
	rm -f books/centaur/bitops/bitsets-opt-raw.o books/centaur/vl/util/gc-raw.o \
		books/centaur/misc/tshell-raw.o books/centaur/vl/Makefile-tmp \
		books/build/Makefile-sources books/build/Makefile-certs 
	dh_clean -XTAGS

debian/acl2-infix.install:: 
	find books/interface/infix -name "*.o" | awk '{a=$$1;sub("/[^/]*$$","",a);printf("%s usr/lib/$(PD)/%s\n",$$1,a);}' >>$@
	find books/interface/infix -name "*.sty" | \
		awk '{a=$$1;sub("/[^/]*$$","",a);printf("%s usr/share/texmf/tex/latex\n",$$1);}' >>$@

debian/acl2-infix-source.install:: 
	find books/interface/infix -name "*.lisp" | awk '{a=$$1;sub("/[^/]*$$","",a);printf("%s usr/lib/$(PD)/%s\n",$$1,a);}' >>$@

debian/acl2-emacs.install:: 
	find books/interface/emacs -name "*.el" | awk '{printf("%s usr/share/emacs/site-lisp/$(PN)\n",$$1);}' >>$@
	find emacs -name "*.el" | awk '{printf("%s usr/share/emacs/site-lisp/$(PN)\n",$$1);}' >>$@

debian/acl2.install:: 
	echo debian/acl2.sh usr/bin >>$@
	echo saved_acl2h usr/lib/$(PD) >>$@

debian/acl2-books.install::
